OGRE: Ogre::RenderQueue Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::RenderQueue Class Reference
Core » RenderSystem

Class to manage the scene object rendering queue. More...

`#include <OgreRenderQueue.h>`

Inheritance diagram for Ogre::RenderQueue:
[legend]

## Classes
class | RenderableListener
| Class to listen in on items being added to the render queue. More...

## Public Types
typedef std::unique_ptr< RenderQueueGroup > | RenderQueueGroupMap[RENDER_QUEUE_COUNT]

## Public Member Functions
| RenderQueue ()
virtual | ~RenderQueue ()
const RenderQueueGroupMap & | _getQueueGroups () const
| Internal method, returns the queue groups.
void | addRenderable (Renderable *pRend)
| Add a renderable object to the queue.
void | addRenderable (Renderable *pRend, uint8 groupId)
| Add a renderable object to the queue.
void | addRenderable (Renderable *pRend, uint8 groupID, ushort priority)
| Add a renderable object to the queue.
void | clear (bool destroyPassMaps=false)
| Empty the queue - should only be called by SceneManagers.
uint8 | getDefaultQueueGroup (void) const
| Gets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.
ushort | getDefaultRenderablePriority (void) const
| Gets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.
RenderQueueGroup * | getQueueGroup (uint8 qid)
| Get a render queue group.
RenderableListener * | getRenderableListener (void) const
bool | getShadowCastersCannotBeReceivers (void) const
| Gets whether or not objects which cast shadows should be treated as never receiving shadows.
bool | getSplitNoShadowPasses (void) const
| Gets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.
bool | getSplitPassesByLightingType (void) const
| Gets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.
void | merge (const RenderQueue *rhs)
| Merge render queue.
void | processVisibleObject (MovableObject *mo, Camera *cam, bool onlyShadowCasters, VisibleObjectsBoundsInfo *visibleBounds)
| Utility method to perform the standard actions associated with getting a visible object to add itself to the queue.
void | setDefaultQueueGroup (uint8 grp)
| Sets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.
void | setDefaultRenderablePriority (ushort priority)
| Sets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.
void | setRenderableListener (RenderableListener *listener)
| Set a renderable listener on the queue.
void | setShadowCastersCannotBeReceivers (bool ind)
| Sets whether or not objects which cast shadows should be treated as never receiving shadows.
void | setSplitNoShadowPasses (bool split)
| Sets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.
void | setSplitPassesByLightingType (bool split)
| Sets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.

## Detailed Description

Class to manage the scene object rendering queue.

Objects are grouped by material to minimise rendering state changes. The map from material to renderable object is wrapped in a class for ease of use.

  This class now includes the concept of 'queue groups' which allows the application adding the renderable to specifically schedule it so that it is included in a discrete group. Good for separating renderables into the main scene, backgrounds and overlays, and also could be used in the future for more complex multipass routines like stenciling.

## Member Typedef Documentation

## ◆ RenderQueueGroupMap

typedef std::unique_ptr<RenderQueueGroup> Ogre::RenderQueue::RenderQueueGroupMap[RENDER_QUEUE_COUNT]

## Constructor & Destructor Documentation

## ◆ RenderQueue()

Ogre::RenderQueue::RenderQueue | ( |  | ) |

Referenced by merge(), and Ogre::RenderQueue::RenderableListener::renderableQueued().

## ◆ ~RenderQueue()

virtual Ogre::RenderQueue::~RenderQueue | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ clear()

void Ogre::RenderQueue::clear | ( | bool | destroyPassMaps = false | ) |

Empty the queue - should only be called by SceneManagers.

Parameters

  destroyPassMaps | Set to true to destroy all pass maps so that the queue is completely clean (useful when switching scene managers)

## ◆ getQueueGroup()

RenderQueueGroup * Ogre::RenderQueue::getQueueGroup | ( | uint8 | qid | ) |

Get a render queue group.

OGRE registers new queue groups as they are requested, therefore this method will always return a valid group.

## ◆ addRenderable() [1/3]

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend,
|  | uint8 | groupID,
|  | ushort | priority )

Add a renderable object to the queue.

This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the advanced version of the call which allows the renderable to be added to any queue.

Note
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters

  pRend | Pointer to the Renderable to be added to the queue
  groupID | The group the renderable is to be added to. This can be used to schedule renderable objects in separate groups such that the SceneManager respects the divisions between the groupings and does not reorder them outside these boundaries. This can be handy for overlays where no matter what you want the overlay to be rendered last.
  priority | Controls the priority of the renderable within the queue group. If this number is raised, the renderable will be rendered later in the group compared to it's peers. Don't use this unless you really need to, manually ordering renderables prevents OGRE from sorting them for best efficiency. However this could be useful for ordering 2D elements manually for example.

## ◆ addRenderable() [2/3]

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend,
|  | uint8 | groupId )

Add a renderable object to the queue.

This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the simplified version of the call which does not require a priority to be specified. The queue priority is take from the current default (see setDefaultRenderablePriority).

Note
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters

  pRend | Pointer to the Renderable to be added to the queue
  groupId | The group the renderable is to be added to. This can be used to schedule renderable objects in separate groups such that the SceneManager respects the divisions between the groupings and does not reorder them outside these boundaries. This can be handy for overlays where no matter what you want the overlay to be rendered last.

## ◆ addRenderable() [3/3]

void Ogre::RenderQueue::addRenderable | ( | Renderable * | pRend | ) |

Add a renderable object to the queue.

This methods adds a Renderable to the queue, which will be rendered later by the SceneManager. This is the simplified version of the call which does not require a queue or priority to be specified. The queue group is taken from the current default (see setDefaultQueueGroup). The queue priority is take from the current default (see setDefaultRenderablePriority).

Note
  Called by implementation of MovableObject::_updateRenderQueue.

Parameters

  pRend | Pointer to the Renderable to be added to the queue

## ◆ getDefaultQueueGroup()

uint8 Ogre::RenderQueue::getDefaultQueueGroup | ( | void |  | ) | const

Gets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.

## ◆ setDefaultRenderablePriority()

void Ogre::RenderQueue::setDefaultRenderablePriority | ( | ushort | priority | ) |

Sets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.

## ◆ getDefaultRenderablePriority()

ushort Ogre::RenderQueue::getDefaultRenderablePriority | ( | void |  | ) | const

Gets the current default renderable priority, which will be used for all renderables which do not specify which priority they wish to use.

## ◆ setDefaultQueueGroup()

void Ogre::RenderQueue::setDefaultQueueGroup | ( | uint8 | grp | ) |

Sets the current default queue group, which will be used for all renderable which do not specify which group they wish to be on.

See the enum RenderQueueGroupID for what kind of values can be used here.

## ◆ _getQueueGroups()

const RenderQueueGroupMap & Ogre::RenderQueue::_getQueueGroups | ( |  | ) | const
| inline

Internal method, returns the queue groups.

## ◆ setSplitPassesByLightingType()

void Ogre::RenderQueue::setSplitPassesByLightingType | ( | bool | split | ) |

Sets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.

## ◆ getSplitPassesByLightingType()

bool Ogre::RenderQueue::getSplitPassesByLightingType | ( | void |  | ) | const

Gets whether or not the queue will split passes by their lighting type, ie ambient, per-light and decal.

## ◆ setSplitNoShadowPasses()

void Ogre::RenderQueue::setSplitNoShadowPasses | ( | bool | split | ) |

Sets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.

## ◆ getSplitNoShadowPasses()

bool Ogre::RenderQueue::getSplitNoShadowPasses | ( | void |  | ) | const

Gets whether or not the queue will split passes which have shadow receive turned off (in their parent material), which is needed when certain shadow techniques are used.

## ◆ setShadowCastersCannotBeReceivers()

void Ogre::RenderQueue::setShadowCastersCannotBeReceivers | ( | bool | ind | ) |

Sets whether or not objects which cast shadows should be treated as never receiving shadows.

## ◆ getShadowCastersCannotBeReceivers()

bool Ogre::RenderQueue::getShadowCastersCannotBeReceivers | ( | void |  | ) | const

Gets whether or not objects which cast shadows should be treated as never receiving shadows.

## ◆ setRenderableListener()

void Ogre::RenderQueue::setRenderableListener | ( | RenderableListener * | listener | ) |
| inline

Set a renderable listener on the queue.

There can only be a single renderable listener on the queue, since that listener has complete control over the techniques in use.

## ◆ getRenderableListener()

RenderableListener * Ogre::RenderQueue::getRenderableListener | ( | void |  | ) | const
| inline

## ◆ merge()

void Ogre::RenderQueue::merge | ( | const RenderQueue * | rhs | ) |

Merge render queue.

References RenderQueue().

## ◆ processVisibleObject()

void Ogre::RenderQueue::processVisibleObject | ( | MovableObject * | mo,
|  | Camera * | cam,
|  | bool | onlyShadowCasters,
|  | VisibleObjectsBoundsInfo * | visibleBounds )

Utility method to perform the standard actions associated with getting a visible object to add itself to the queue.

This is a replacement for SceneManager implementations of the associated tasks related to calling MovableObject::_updateRenderQueue.

The documentation for this class was generated from the following file:

- OgreRenderQueue.h